#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Chart;

namespace ChartDragDrop
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		private bool isDragging = false;
		private ChartRegion currentRegion = null;
		private double xmin;
		private double ymax;
		private double ymin;
		private double xmax;
		private Point chartAreaPoint;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InitializeControlSettings();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void InitializeControlSettings()
		{
			this.chartControl1.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));

			// Specify a ChartPalette:
			Color[] color = new Color[]{Color.FromArgb(185, 73,141,238), Color.FromArgb(185,247,179,78),Color.FromArgb(185,186,66,30)};
			this.chartControl1.Palette = ChartColorPalette.Custom ;

			this.chartControl1.Model.ColorModel.CustomColors = color;
			this.chartControl1.Palette = ChartColorPalette.Custom ;

			this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(185,new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, Color.LightBlue , Color.Azure));
			this.chartControl1.LegendPosition = ChartDock.Top;
			
			this.chartControl1.HidePartialLabels = true;
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
			this.SuspendLayout();
			// 
			// chartControl1
			// 
			this.chartControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.chartControl1.Controls.AddRange(new System.Windows.Forms.Control[] {
																						this.chartControl1.Legend});
			// 
			// chartControl1.Legend
			// 
			this.chartControl1.Legend.Font = new System.Drawing.Font("Verdana", 10F);
			this.chartControl1.Legend.ItemsShadowColor = System.Drawing.Color.Gray;
			this.chartControl1.Legend.Location = new System.Drawing.Point(462, 193);
			this.chartControl1.Legend.TabIndex = 3;
			this.chartControl1.Name = "chartControl1";
			this.chartControl1.PrimaryXAxis.LabelAligment = System.Drawing.StringAlignment.Center;
			this.chartControl1.PrimaryXAxis.Orientation = Syncfusion.Windows.Forms.Chart.ChartOrientation.Horizontal;
			this.chartControl1.PrimaryYAxis.LabelAligment = System.Drawing.StringAlignment.Center;
			this.chartControl1.Size = new System.Drawing.Size(560, 376);
			this.chartControl1.TabIndex = 0;
			this.chartControl1.Text = "Essential Chart";
			this.chartControl1.ToolBar.Location = new System.Drawing.Point(0, 0);
			this.chartControl1.ChartRegionMouseDown += new Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventHandler(this.chartControl1_ChartRegionMouseDown);
			this.chartControl1.ChartRegionMouseHover += new Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventHandler(this.chartControl1_ChartRegionMouseHover);
			this.chartControl1.ChartRegionMouseUp += new Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventHandler(this.chartControl1_ChartRegionMouseUp);
			this.chartControl1.ChartRegionMouseMove += new Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventHandler(this.chartControl1_ChartRegionMouseMove);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(552, 374);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.chartControl1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "Essential Chart - Chart Drag & Drop Sample";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			InitializeChartData();
			
		}

		/// <summary>
		/// Initializes chart data
		/// </summary>
		protected void InitializeChartData()
		{
			ChartSeries series = this.chartControl1.Model.NewSeries("Drag and Drop Series",ChartSeriesType.Line);
			series.Text = series.Name;

			series.Points.Add(1,45);
			series.Points.Add(2,26);
			series.Points.Add(3,17);
			series.Points.Add(4,29);
			series.Points.Add(5,38);
			series.Points.Add(6,26);

			series.PrepareStyle+=new ChartPrepareStyleInfoHandler(this.line_preparestyle);

			this.chartControl1.Series.Add(series);
			
		}

		protected void GetAxisValues()
		{
			xmin = this.chartControl1.PrimaryXAxis.Range.Min;
			ymax = this.chartControl1.PrimaryYAxis.Range.Max;
			ymin = this.chartControl1.PrimaryYAxis.Range.Min;
			xmax = this.chartControl1.PrimaryXAxis.Range.Max;
		}

		/// <summary>
		/// The chart mouse down event
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void chartControl1_ChartRegionMouseDown(object sender, Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventArgs e)
		{
			if(e.Region.IsChartPoint)
			{
				Cursor = Cursors.SizeAll;
				this.isDragging = true;
				this.currentRegion = e.Region;
			}
		}

		/// <summary>
		/// The chart mouse up event
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void chartControl1_ChartRegionMouseUp(object sender, Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventArgs e)
		{
			Cursor = Cursors.SizeAll;
			if(this.isDragging)
			{
				GetAxisValues();

				//Screen Coordinates to ChartArea coordinates
				chartAreaPoint = ConvertScreenPointToChartAreaPoint(Control.MousePosition);

				this.chartControl1.Series[0].Points[this.currentRegion.PointIndex].X = GetXValueForScreenPoint(chartAreaPoint);
				this.chartControl1.Series[0].Points[this.currentRegion.PointIndex].YValues[0] = GetYValueForScreenPoint(chartAreaPoint);
				this.isDragging = false;
				this.currentRegion = null;
			}
			UpdateSeriesStyles();
		}

		/// <summary>
		/// Calculates the X value
		/// </summary>
		/// <param name="areaPoint"></param>
		/// <returns></returns>
		private double GetXValueForScreenPoint(Point areaPoint)
		{
			Point axisStartPoint = this.chartControl1.GetChartAreaCoordinates(xmin,ymin);
			Point axisEndPoint = this.chartControl1.GetChartAreaCoordinates(xmax,ymin);
			Point axisZeroPoint = this.chartControl1.GetChartAreaCoordinates(0,ymin);

			// Pixel lengths
			double fullLength = axisEndPoint.X - axisStartPoint.X;
			double length = axisEndPoint.X - axisZeroPoint.X;
			double axisOrigin = this.chartControl1.ChartArea.ClientRectangle.Width - fullLength - this.chartControl1.ChartAreaMargins.Right;
			double pointX = chartAreaPoint.X - axisOrigin- axisZeroPoint.X;

			double returnVal = pointX/length * xmax;
			return returnVal;
		}

		/// <summary>
		/// Calculates the Y Value
		/// </summary>
		/// <param name="areaPoint"></param>
		/// <returns></returns>
		private double GetYValueForScreenPoint(Point areaPoint)
		{
			Point axisStartPoint = this.chartControl1.GetChartAreaCoordinates(xmin,ymin);
			Point axisEndPoint = this.chartControl1.GetChartAreaCoordinates(xmin,ymax);
			Point axisZeroPoint = this.chartControl1.GetChartAreaCoordinates(0,ymin);

			// Pixel lengths
			double length = axisEndPoint.Y - axisZeroPoint.Y;
			double pointY = chartAreaPoint.Y -  axisZeroPoint.Y;

			double returnVal = pointY/length * ymax;
			return returnVal;
		}

		/// <summary>
		/// Converts screen point to Chartarea point
		/// </summary>
		/// <param name="screenPoint"></param>
		/// <returns></returns>
		private Point ConvertScreenPointToChartAreaPoint(Point screenPoint)
		{
			Rectangle chartAreaRectangle = this.chartControl1.ChartArea.ClientRectangle;

			//We cant directly convert a Screen Point to Chart Area Coordinates
			//This converts the point in screen coordinates to chartcontrol coordinates
			Point ccp = this.chartControl1.PointToClient(screenPoint);

			//This converts the chart point into chartarea coordinates
			Point cap = new Point(ccp.X - chartAreaRectangle.X, ccp.Y - chartAreaRectangle.Y);

			return cap;
		}

		

	
		private void line_preparestyle(object sender,ChartPrepareStyleInfoEventArgs args)
		{
			ChartSeries series = sender as ChartSeries;
			if(series != null)
			{
				args.Style.Symbol.Shape = ChartSymbolShape.Square;
				args.Style.Symbol.Color = Color.DarkGreen;
				args.Style.Symbol.Size = new Size(5,5);
				args.Style.DisplayText =true;
				args.Style.TextColor = Color.Red;
				args.Style.TextFormat = string.Format("{0}",Math.Round(series.Points[args.Index].YValues[0],0));
				args.Style.TextOrientation = ChartTextOrientation.Up;
			}
		}

		

		/// <summary>
		/// Updates the series styles
		/// </summary>
		protected void UpdateSeriesStyles()
		{
			
				this.chartControl1.Series[0].PrepareStyle+=new ChartPrepareStyleInfoHandler(this.line_preparestyle);
							
			this.chartControl1.Refresh();
		}

		private void chartControl1_ChartRegionMouseHover(object sender, Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventArgs e)
		{
			if(e.Region.IsChartPoint)
			{
				Cursor = Cursors.SizeAll;
			}
			else
				Cursor = Cursors.Default;
		}

		private void chartControl1_ChartRegionMouseMove(object sender, Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventArgs e)
		{
			if(e.Region.IsChartPoint)
			{
				Cursor = Cursors.SizeAll;
				this.isDragging = true;
				this.currentRegion = e.Region;
			}
		}
	}
}